         ///////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
         * NOME : ABDISPLAY.PRG                                 *
         * Programador e Autor : Pedro Bagarro                 *
         * FUNO : Display POS  - Restaurao                  *
         * OBJECTIVO DA APLICAO : Pos                         *
         * BASES DE DADOS ASSOCIADAS : *.DBF                    *
         * DATA DE INICIO DO PROJECTO : 23-02-2019              *
         * DATA DA ULTIMA RELEASE : 23-02-2019                  *
         ///////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//////////////////////////////////////////////////////////////////////////////////////////
//REGUA   0....|....10...|....20...|....30...|....40...|....50...|....60...|....70...|...79
//----------- NOTAS DA RELEASE -------------
//////////////////////////////////////////////////////////////////////////////////////////
#include "dcdialog.ch"
#include "dcgra.ch"
#include "dcapp.ch"
#include "dcmsg.ch"

#include "web.ch"

#include "set.ch"
#include "Common.ch"
#include "fileio.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Getexit.ch"
#include "AppEvent.ch"
#include "AppBrow.ch"
#include "Nls.ch"

#include "ABDisplay.ch"

#DEFINE REFRESH_GETLIST xbeP_User + 100

#define PORT 8100
#define SERVERNAME  GetEnv("Computername" )


******************************************************************************
//REGUA          0....|....10...|....20...|....30...|....40...|....50...|....60...|....70...|...79
******************************************************************************
PROCEDURE AppSys
RETURN

/////////////////////////////////////////////////////////////////////////////////
Procedure MAIN()
LOCAL GetOptions, GetList := {}
Local aRef := { 'nLarRes' , 'nAltRes'}
Local aConfig := { '800' , '400' }
LOCAL oHttpEndpoint
Local aBrowPres:={{ XBP_PP_COL_HA_ALIGNMENT, XBPALIGN_HCENTER}     ,;         /* Header Alignement */
            	  { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK           } ,;         /* Row FG Color     */
            	  { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE           } ,;         /* Row BG Color     */
            	  { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE  }          ,;         /* Hilite FG color  */
            	  { XBP_PP_HILITE_BGCLR, GRA_CLR_DARKBLUE }        ,;         /* Hilite BG color  */
        		  { XBP_PP_COL_HA_HEIGHT, 30 },;         /* Header Height    */
        		  { XBP_PP_COL_DA_ROWHEIGHT, 29 },;       /* Row Height       */
        		  { XBP_PP_COL_FA_HEIGHT, 32}}         /* Footer Height    */

Public cNomeArtigo := Space(100)
Public nQtd        := 1
Public nPvp        := 0
Public nTotal      := 0
Public nGTotal     := 0
Public aConta      := {}
Public xData       := {}
Public oMainDialog := nil

DC_IniLoad('ABDisplay.Ini','ABDisplay',aConfig,aRef)

IF ! DC_IniLoad('AppData.Ini','ABDisplay',aConfig,aRef)
	 DC_IniSave('AppData.Ini','ABDisplay',aConfig,aRef)
Endif

set century on
set deleted on
set date format to "dd-mm-yyyy"
set date to system

SetCancel(.f.)
ErrorSys()
DC_DotHotKey(0)

SetLocale( NLS_SDECIMAL, "." )  // Definir Separador Decimal
SetLocale( NLS_STHOUSAND, Space(1) )  // Definir Separador de Milhares

DC_ICONDEFAULT(1)
DC_LANGSET(DCLANG_PORTUGUESE)

Dc_BitMapTransparentColor({192,192,192})

@ 000,000 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 300,450 OBJECT oPan1

DCBITMAP 100 PARENT oPan1 //AUTOSCALE CENTER

@ 000,301 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 500,080 OBJECT oPan2

@ 005,005 dcget cNomeArtigo GETSIZE 490,35 GetFont '23.Arial Bold' Parent oPan2
@ 040,005 dcget nQtd Picture '@e 99 999.999' GETSIZE 130,35 GetFont '23.Arial Bold' Parent oPan2
@ 040,140 dcsay 'X' size 20,35 SayFont '23.Arial Bold' Parent oPan2
@ 040,170 dcget nPvp Picture '@e 99 999.999' GETSIZE 135,35 GetFont '23.Arial Bold' Parent oPan2
@ 040,310 dcsay '=' size 20,35 SayFont '23.Arial Bold' Parent oPan2
@ 040,335 dcget nTotal Picture '@e 99 999.999' GETSIZE 160,35 GetFont '23.Arial Bold' Parent oPan2

@ 080,301 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 500,300 OBJECT oPan3

@ 000,000 DCBROWSE oBrowConta DATA aConta     ;
SIZE 500,295                         ;
PIXEL                                ;
FIT                                  ;
PRESENTATION aBrowPres               ;
CURSORMODE XBPBRW_CURSOR_ROW         ;
NOHSCROLL                            ;
NOVSCROLL                            ;
FONT '14.Arial Bold'                 ;
FREEZELEFT {}                        ;
RESIZECOLUMNS                        ;			//RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT       ;
PARENT oPan3

DCBROWSECOL ELEMENT 1 PARENT oBrowConta HEADER 'Qtd' HCOLOR GRA_CLR_WHITE, GRA_CLR_BLACK ;
			WIDTH 80 PICTURE '@e 999.99' ALIGN XBPALIGN_RIGHT PIXEL

DCBROWSECOL ELEMENT 2 PARENT oBrowConta HEADER 'Descritivo' HCOLOR GRA_CLR_WHITE, GRA_CLR_BLACK PIXEL;
			WIDTH 300

DCBROWSECOL ELEMENT 3 PARENT oBrowConta HEADER 'Total' HCOLOR GRA_CLR_WHITE, GRA_CLR_BLACK ;
			WIDTH 120 PICTURE '@e 999999.99' ALIGN XBPALIGN_RIGHT PIXEL

DCUSEREVENT REFRESH_GETLIST ACTION {||DC_GetRefresh(GetList)}

@ 380,301 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 500,070 OBJECT oPan4


@ 00,00 dcpushbutton      ;
Caption 'Refresh'         ;
size 70,70                ;
action {|| Dc_GetRefresh(GetList) } ;
PARENT oPan4

@ 05,130 DcSay '  Total'  Get nGTotal Picture '@e 99 999.99' SAYRIGHT ;
Parent oPan4 ;
SayFont '35.Arial Bold' ;
SaySize 150,60 ;
GetFont '35.Arial Bold' ;
GETSIZE 200,60 ;
Pixel EditProtect {||.t.}

oHttpEndpoint := HttpEndpoint():new( PORT )
oHttpEndpoint:start()

DCGETOPTIONS ;
PIXEL ;
EDITPROTECT {|| .t. } ;
NOMAXBUTTON NOMINBUTTON ;
WINDOWWIDTH Val(aConfig[1]) ;
WINDOWHEIGHT val(aConfig[2])

DCREAD GUI         ;
FIT                ;
OPTIONS GetOptions ;
PARENT @oMainDialog

oHttpEndpoint:stop()

Return
//======================================================
Static Function Refresh( GetList )

do while .t.
	sleep(50)
	Dc_GetRefresh(GetList)
Enddo

Return Nil

//==============================================================
CLASS EchoServer FROM WebSocketHandler
  EXPORTED:
    METHOD onConnect
    METHOD onDisconnect
    METHOD onText
    METHOD onBinary
ENDCLASS

//------------------------------------------------
METHOD EchoServer:onConnect()
//WTF 'Connected'
RETURN self

//------------------------------------------------
METHOD EchoServer:onDisconnect()
//WTF 'DisConnected'
RETURN self

//------------------------------------------------
METHOD EchoServer:onText( cText )
//WTF cText

//DCMSGBOX "Chegou a Mensagem " + cText FONT '12.Lucida Console Bold'

//::sendText( cText )
RETURN self

//------------------------------------------------
METHOD EchoServer:onBinary( cBinary )

xData := Bin2Var(cBinary)

	IF Len( xData ) > 0
		cNomeArtigo := xData[1]
		nQtd        := xData[2]
		nPvp        := xData[3]
		nTotal      := nQtd*nPvp
		nGTotal     += nTotal
		aadd( aConta, {nQtd,cNomeArtigo,nTotal} )
      PostAppEvent(REFRESH_GETLIST,,,oMainDialog)
      Sleep(1)
   Endif


RETURN self





