#INCLUDE "dcdialog.CH"

#define SERVERNAME  GetEnv("Computername" )
#define PORT        8100

PROCEDURE Main
LOCAL oEchoClient, GetList[0], oThread, n:=1
LOCAL aDataSend := {{'Batatas',12.55,65.78},{'Tomates',72.45,95.58},{'Cenouras',92.35,25.18}}

oEchoClient := EchoClient():new( SERVERNAME,   ;
                                 "EchoServer", ;
                                 PORT )

IF .NOT. oEchoClient:connect()
  DCMSGBOX "Connection failed to server " + SERVERNAME + ':' + Alltrim(Str(PORT)) ;
     FONT '12.Lucida Console'
  RETURN
ENDIF

//
// As long as the connection is active
// handle all messages sent from the server
// in non blocking mode.
//

oThread := Thread():new()
Sleep(5)
oThread:start({|| EchoClientLoop(oEchoClient) })

@ 0,0 DCPUSHBUTTON CAPTION 'Send Data' SIZE 35,1.8 ;
      ACTION {|| SendData( oEchoClient, aDataSEnd[n], IF( n<Len(aDataSEnd),n++,n:=1) )} ;
      FONT '16.Lucida Console'

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON

DCREAD GUI TITLE 'WebSocket Client' FIT OPTIONS GetOptions

RETURN

* -----------

PROC appsys ; RETURN

* -----------

STATIC FUNCTION EchoClientLoop( oEchoClient )

LOCAL lHandled

DO WHILE oEchoClient:isConnected()
  lHandled := oEchoClient:handleMessage( .F. )
  Sleep(5)
ENDDO

RETURN nil

* -----------

STATIC FUNCTION SendData( oEchoClient, xData )

LOCAL lStatus := .f.

IF !oEchoClient:isConnected()
  DCMSGBOX "Connection failed to server " + SERVERNAME + ':' + Alltrim(Str(PORT)) ;
     FONT '12.Lucida Console'
ELSE
  oEchoClient:sendBinary(Var2Bin(xData))
  lStatus := .t.
ENDIF

RETURN nil


//
// The class echo client serves as client
// side of the EchoServer
//
CLASS EchoClient FROM WSCustomClient
  EXPORTED
    METHOD onText
    METHOD onConnect
    METHOD onDisconnect
    METHOD onBinary
ENDCLASS

//
// Implement the methods used by the
// EchoClient class
//
METHOD EchoClient:onText( cText )
  //WTF cText COLOR GRA_CLR_DARKRED
RETURN self

METHOD EchoClient:onBinary( cBinary )
  //WTF Bin2Var(cBinary) COLOR GRA_CLR_DARKRED
RETURN self

METHOD EchoClient:onConnect()
  //WTF 'Connected'
RETURN self

METHOD EchoClient:onDisconnect()
  //WTF 'DisConnected'
RETURN

/*
 *  Derive from this class instead from
 */

CLASS WSCustomClient FROM WebSocketClient
   PROTECTED:
      VAR _AbortOnFailure
   EXPORTED:
      METHOD init()
      METHOD sendBinary()

      ACCESS METHOD getAbortOnFailure VAR AbortOnFailure
      ASSIGN METHOD setAbortOnFailure VAR AbortOnFailure
ENDCLASS

METHOD WSCustomClient:init()
   ::_AbortOnFailure := .T.
   SUPER
RETURN SELF

METHOD WSCustomClient:sendBinary( cBinary )
   LOCAL cType
   LOCAL cXOred
   LOCAL cMask

   //wtf cBinary

   IF ::_AbortOnFailure

      cType := ValType( cBinary )
      IF .NOT. "C" == cType
         Exception():raiseParameterType( cBinary )
      ENDIF

   ENDIF

   IF ::_AbortOnFailure

      cMask  := RandomValue( 4 )
      cXOred := BXOR(cBinary, cMask)

      cType := ValType( cXOred )
      IF .NOT. "C" == cType
         Exception():raiseParameterType( cXOred )
      ENDIF

   ENDIF

   SUPER
RETURN self

METHOD WSCustomClient:getAbortOnFailure()
RETURN ::_AbortOnFailure

METHOD WSCustomClient:setAbortOnFailure( lAbortOnFailure )
   ::_AbortOnFailure := lAbortOnFailure
RETURN SELF



FUNCTION RandomValue( nLen )
RETURN RandomKey( nLen )



